#include "PreferencesDialog.h"

namespace loglan {
namespace vlp {
namespace dialog {

PreferencesDialog::PreferencesDialog(QWidget * parent)
	: QDialog(parent)
{
	setupUi(this);

	connect(buttonBox, SIGNAL(accepted()), this, SLOT(accept()));
	connect(buttonBox, SIGNAL(rejected()), this, SLOT(reject()));
}

PreferencesDialog::~PreferencesDialog()
{
}

QString PreferencesDialog::getCompilerPath()
{
	return compilerPath->text();
}

void PreferencesDialog::setCompilerPath(QString path)
{
	return compilerPath->setText(path);
}

QString PreferencesDialog::getFilesPath()
{
	return filesPath->text();
}

void PreferencesDialog::setFilesPath(QString path)
{
	return filesPath->setText(path);
}

QString PreferencesDialog::getGenPath()
{
	return genPath->text();
}

void PreferencesDialog::setGenPath(QString path)
{
	return genPath->setText(path);
}

}
}
}
