#ifndef _VLP_KERNEL_MESSAGEDIALOG_H
#define _VLP_KERNEL_MESSAGEDIALOG_H

#include <QtGui/QDialog>

#include "ui/dialogs/MessageDialog.h"

/**
 * @file
 */

namespace loglan {
namespace vlp {
namespace dialog {

/**
 * Message Dialog class
 */
class MessageDialog : public QDialog, private Ui::MessageDialog {
public:
	MessageDialog(QWidget * parent = 0);
	~MessageDialog();

	int getNodeNumber();
	QString getMessage();
};

}
}
}

#endif /* _VLP_KERNEL_MESSAGEDIALOG_H */
